// Filter Popup 1.0 by MexicanSquirrel
// Email: dan-martins@home.com

// Changes the filter text to a nice little popup menu.

// If you know how to change the text in the popup to look like everything else, please let me know.

new ShellPopupMenu(FilterPopup) {
	profile = "ShellPopupProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "46 -3";
	extent = "195 36";
	minExtent = "49 36";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";
	maxLength = "255";
	maxPopupHeight = "200";
	buttonBitmap = "gui/shll_pulldown";
	rolloverBarBitmap = "gui/shll_pulldownbar_rol";
	selectedBarBitmap = "gui/shll_pulldownbar_act";
	noButtonStyle = "0";
};

package FilterPopup {


	function FilterPopupSetup() {
		if (isObject(GMJ_FilterText))
			GMJ_FilterText.delete();
		
		GM_JoinPane.remove(FilterPopup);
		GM_JoinPane.add(FilterPopup);
		
		FilterPopup.clear();
		
		FilterPopup.add("All Servers", 0, 1);
		FilterPopup.add("Buddies", 1, 1);
		FilterPopup.add("Favorites", 2, 1);
		
		for (%i = 0; $pref::ServerBrowser::Filter[%i] !$=  ""; %i++)
			FilterPopup.add(getField($pref::ServerBrowser::Filter[%i], 0), %i + 3, 1);
		
		FilterPopup.setSelected($pref::ServerBrowser::activeFilter);
	}

	function GameGui::onWake(%this) {
		parent::onWake(%this);
		FilterPopupSetup();
	}

	function ChooseFilterDlg::onSleep(%this) {
		parent::onSleep(%this);

		FilterPopupSetup();
	}

	function FilterPopup::onSelect(%this, %id, %text) {
		
		// set the selected item as the current filter
		$pref::ServerBrowser::activeFilter = %id;
		GMJ_Browser.runQuery();
	}


}; //package FilterPopup

activatePackage(FilterPopup);
