//--------------------------------------------------------------------------
//  Version 2.0
// *VoicePack Template - Jimbo2000[D6] and Govt.Cheese[D6]
//  4-19-01
//--------------------------------------------------------------------------

//alright, this first section is the MAIN piece of work you'll have to do to create a new soundpack.
//every line in this file is for a separate .wav file - basically, tribes 2 needs you
//to associate each wav file with a 'messagebinding' name, and this is how its done.

// To build a client-side voice pack, which autoregisters with the main program
//  there are two steps. One is to beuild this file and the other is to create a 
//  file that gets put in base/scripts/autoexec

// This file describes what you have to do for the first part. To handle the autoload
// see the Templateautoload.cs file.

//here's how it works: we'll go piece by piece:
//for each wav file, do the following:

//installChatItem( 'messagebinding', "text", "Kfilename", 0, false, "VZE", false);

//messagebinding - THIS is what you want the sound to be known as from now on..
//whenever you reference it in another file, or in a message, or in the custom 
//voice menu builder or ANYWHERE, it will be called whatever you put in A.
//We suggest you use something of the form PACKname, where PACK is the name
//of your overall sound pack, and name is something referring to the specific file.
//This is so there is NO way you are using the same name that some other sound pack is 
//already using, which would cause problems.

//text - This is what will appear in the chat window when your sound is played. Pretty 
//straightforward.

//Kfilename - This is the filename of your wav. All the wavs you want in the pack should be
//located in Tribes2/base/audio/voice/custom/. 
//for instance, if your file is named hello.wav, for this you put "Khello"
//
//***********************THIS IS EXTREMELY IMPORTANT***********************
// Your pack will NOT work with our script UNLESS you start each wav name in this file
// with an EXTRA K - hello.wav would go in this as "Khello.wav". kill.wav would show up as
// "Kkill.wav". We again use the soundpack name to start our filenames, so our wav
// D6flag.alltooeasy is "KD6flag.alltooeasy" here in this entry.
// DO NOT LEAVE OFF THIS EXTRA K OR IT WILL NOT WORK!!!!!! THE CASE IS VERY 
// IMPORTANT, IT MUST BE UPPER CASE K
//**************************************************************************
//
//If you WANT, instead of putting your files in Tribes2/base/audio/voice/custom/
//you can put your wav files in a .vl2 file (this is just a .zip 
//file, with the .zip extension renamed to .vl2) - to DO this, put your files in the 
//Tribes2/base/audio/voice/custom/ directory, then ZIP up the WHOLE audio directory,
//and ALL its subdirectories, keeping the directory structure INTACT. 
//throw this .vl2, (named whatever you want) into Tribes2/base and it should
//work fine PROVIDED you have done this all correctly.

//finally, there is the -  0, false, "VZE", false) section...

//the 0 means that this is a VOICE command, setting it to 1 means its an animation..
// we haven't played with animations at all, so if you set it to 1 you are on your own!

//The first false is whether you want it to play to your TEAM only (true), 
// or to EVERYONE (false).

// the "VZE" is the letter combination needed to play the sound - by default that is.
// V to bring up the chat menu, then Z, then E in this case
// This is very dependent on how you lay things out in the VoiceBinds.cs file (check
// out our templateVoiceBinds.cs file)  - we dont think what you put here ACTUALLY matters
// at all in terms of where your sound goes on the menu - that is ALL done in the
// templateVoiceBinds.cs file - BUT, what you put here is what shows up at the 
// beginning of your text, in little brackets. (So other people with the pack know how
// to play the sound);

//the last false has to do with 3D sound... unless you really know 
//what it does, just leave it as false.

//---------------------------------------------------

//and lastly, here are a few samples of how we bound things and kept our 
//sound categories straight and such:

//(make sure you DELETE these, or at least comment them out, 
// if you ever end up using this template as a finished sound pack!)

//also, RENAME this file to something else when you are done with it!


//----------------------------------------------
// D6 - FLAG
installChatItem( 'D6FlagAllTooEasy', "All too easy.", "KD6flag.alltooeasy", 0, false, "VZf1", false );
installChatItem( 'D6FlagDoingTheirPart', "They're doing their part, are you?", "KD6flag.areyou", 0, false, "VZf2", false );
installChatItem( 'D6FlagAustinWhip', "Austin 3:16 says I just whipped your ass!", "KD6flag.austin316", 0, false, "VZF3", false );
installChatItem( 'D6FlagBartGod', "Today I am a god.", "KD6flag.bartgod", 0, false, "VZF4", false );
installChatItem( 'D6FlagBeaten', "You are beaten. It is useless to resist.", "KD6flag.beaten", 0, false, "VZF5", false );
installChatItem( 'D6FlagBorn', "Ever have that feeling you were just born for greatness?", "KD6flag.born", 0, false, "VZF6", false );
installChatItem( 'D6FlagCheese', "BEHOLD THE POWER OF CHEESE!", "KD6flag.cheese", 0, false, "VZF7", false );
//-----------------------------------------------
//D6 - DEATH
installChatItem( 'D6DieAmpheta', "Looks like I picked the wrong week to quit amphetamines.", "KD6die.amphetim", 0, false, "VZD1", false );
installChatItem( 'D6DieAnother', "Thank you sir may I have another!", "KD6die.another", 0, true, "VZD2", false );
installChatItem( 'D6DiePink', "Is there any way of getting in and out of this place without this happening all the time?", "KD6die.wpink", 0, false, "VZD3", false );
installChatItem( 'D6DieRepressed', "Help! Help! I'm being repressed!.", "KD6die.repress", 0, false, "VZD4", false );
installChatItem( 'D6DieDeathtoll', "The death toll is catastrophic.", "KD6die.deathtoll", 0, false, "VZD5", false );
installChatItem( 'D6DieDepress', "I am depressed.", "KD6die.depress", 0, false, "VZD6", false );
installChatItem( 'D6DieGoogly', "Great googly moogly.", "KD6die.googly", 0, false, "VZD7", false );
installChatItem( 'D6DieHairFire', "My hair is on fire! My hair is on fire!", "KD6die.hairfire", 0, false, "VZD7", false );
installChatItem( 'D6DieKillAll', "We've gotta stop 'em! There gonna kill us all!", "KD6die.killall", 0, false, "VZD8", false );


//This part is a LOT easier than the above section
//
//basically this builds the submenu that your voicepack will use...
//in our opinion this is BETTER than going into the game, and creating a 
//custom menu for your soundpack, then saving that file... because THIS
//method allows your soundpack menu to be ADDED to the existing menu,
//not to replace it - so multiple soundpacks can work without
//worrying much about each other.

//This is pretty straightforward... the ONLY THING you have to worry about
//is the very first line on the page.. 

//for us: startChatMenu( "Z D6" );
// this means we're adding a menu item called 'D6' that can be referenced from the
// main chat menu by pressing Z.
//*****************************************************
// the ONLY THING we have to worry about is that we are the only one who uses 'Z'
// in the FIRST LEVEL of the MAIN chat menu.
//****************************************************
// for many soundpacks to be in the menu at once, they all have to have a 
// different letter or number here. (you can still HEAR them no matter what, but to have
// them in the menu, you need your own letter or number.)

//***************************************************************
// for now, just try to pick a letter or number no one else is using - there's no great
// way to do this aside from TELLING  everyone who downloads your pack that IF they
// have something already bound to the letter you use here, then one of the letters has to 
// change.. and tell them how to change it!
//***************************************************************

//and DONT USE Z - thats ours! We got here first, so back off! :)


//now, everything here is in terms of menus and submenus.
//look at our sample code below:
//the first line adds the menu 'D6' to the main chat menu (the one you pull up with V)
//The second line adds a submenu UNDER the menu D6, called 'capture flag'..
// this is acessed by pressing C once in the D6 menu.

//now, under this are a bunch of addChat commands:
//addChat( "1 All too easy", 'D6FlagAllTooEasy' );
//this adds a sound, with the description of "All too Easy" to the submenu
//we are currently in (Capture Flag). The sound is played by pressing 1, and
//the last part, 'D6FlagAllTooEasy' is the messagebinding of the wav - THIS
//is where the messagebindings you added in TemplateChatItems.cs come into play.
//THEY are what you use to describe the wav file you want.  

//at the end of all the addChat's is the command endChatMenu();
//this basically backs us out one menu level - now we're back in the D6 menu.

//the next part, startChatMenu( "D Drop Flag" );
//and            endChatMenu():
//adds a submenu under D6 that has NO sounds in it right now..

//look farther down the code for examples on how to make
//submenus under submenus... For instance, the Taunts submenu is divided into
//Some Taunts and More Taunts submenus.

//look at how we've indented things to get an idea of where they go. This is pretty
//easy once you try it.

// This file must be named very carefully to get autoloading form the main part right.
// 

startChatMenu( "Z D6" );
	startChatMenu( "C Capture Flag" );
		addChat( "1 All too easy", 'D6FlagAllTooEasy' );
		addChat( "2 Doing their part", 'D6FlagDoingTheirPart' );
		addChat( "3 Austin 3:16", 'D6FlagAustinWhip');
		addChat( "4 Bart God", 'D6FlagBartGod');
		addChat( "5 You are Beaten", 'D6FlagBeaten');
		addChat( "6 Born for Greatness", 'D6FlagBorn');
		addChat( "7 Power of Cheese", 'D6FlagCheese');
		addChat( "8 I am your Father", 'D6FlagFather');
		addChat( "9 Goooaaaal", 'D6FlagGoal');
		addChat( "0 Groovy!", 'D6FlagGroovy');
		addChat( "q Hail to The King", 'D6FlagHail');
		addChat( "w Halleluia", 'D6FlagHalleluia');
		addChat( "e HooHoo", 'D6FlagHoho');
		addChat( "r Kick Ass for Lord", 'D6FlagLord');
		addChat( "t Moon Land", 'D6FlagLanded');
		addChat( "y Give me some Suger", 'D6FlagSugar');
		addChat( "u Yeah Baby", 'D6FlagYeahBaby');
	endChatMenu();
	startChatMenu( "D Drop Flag" );
			
	endChatMenu();
	startChatMenu( "T Taunts" );
		startChatMenu( "1 Some Taunts" );
			addChat("1 Pardon French",'D6TntAsshole');
			addChat("2 Bleed on me?",'D6TntBleed');
			addChat("3 Collection of victums",'D6TntCollect');
			addChat("4 Hit me",'D6TntComeon');
			addChat("5 Democrats",'D6TntDemo');
			addChat("6 No dick!",'D6TntDick');
			addChat("7 Disappear Scumbag!",'D6TntDisappear');
			addChat("8 Failure",'D6TntFailure');
			addChat("9 Fart",'D6TntFart');
			addChat("0 Fill your hands",'D6TntFillhands');
			addChat("Q Go away boy",'D6TntFoghorn');
			addChat("W Foodchain",'D6TntFoodchain');
			addChat("E Weak fool!",'D6TntFool');
			addChat("R Come Get some!",'D6TntGetsome');
			addChat("T Your going down!",'D6TntGoingdown');
			addChat("Y Brain is Gone!",'D6TntBrainGone');
		endChatMenu();
		startChatMenu( "2 More Taunts" );
			addChat("1 Loser!",'D6TntLoser');
			addChat("2 Malfunction",'D6TntMalfunc');
			addChat("3 Monkey",'D6TntMonkey');
			addChat("4 Motherless goat!",'D6TntMother');
			addChat("5 Sense fear",'D6TntMuchfear');
			addChat("6 Newbie",'D6TntNewbie');
			addChat("7 Pound You",'D6TntPound');
			addChat("8 Resistance",'D6TntResist');
			addChat("9 Silence",'D6TntSilence');
			addChat("0 Crack skulls!",'D6TntSkulls');
			addChat("Q Stupid people!",'D6TntStupid');
			addChat("W Athletic supporter",'D6TntSupporter');
			addChat("E Idiots!",'D6TntSurrond');
			addChat("R Price Wrong",'D6TntPrice');
			addChat("T Hell are you?",'D6TntWhoHell');
			addChat("Y Shut up",'D6TntMouth');
		endChatMenu();
	endChatMenu(); //Main taunts
	startChatMenu( "K Kill Flag Carrier" );
		addChat("1 Apu",'D6KcarApu');
		addChat("2 Not Come Back",'D6KcarComeback');
		addChat("3 Best you can do!",'D6KcarBest');
		addChat("4 Mercy Church",'D6KcarChurch');
		addChat("5 Don't cowboy!",'D6KcarCowboy');
		addChat("6 Evil Truimph", 'D6KcarGoodDumb');
		addChat("7 It is done",'D6KcarItisdone');
		addChat("8 Revenge Sweet",'D6KcarRevenge');
		addChat("9 No Soup",'D6KcarSoup');
		addChat("0 Weener Boy",'D6KcarWeener');
	endChatMenu();


endChatMenu();