// #autoload
// #name = TwoRes
// #version = 1.1.0
// #status = release
// #date = May 05, 2001
// #description = Twostep's automatic resolution switching script
// #author = Twostep-=VuP=-
// #warrior = Twostep
// #email = josh@goldshlag.com
// #web = http://www.goldshlag.com
// #config = TwoResOptionsGui

// Twostep's Auto Resolution Switching Script

// This script lets you run in high res windowed mode for the community
// parts of the game, and when you join a server this sets the resolution
// to whatever you wants and switches to windowed mode, if you want.

deactivatePackage(TwoRes);

$TwoRes::playing = false;

package TwoRes
{	
	function LoadingGui::onWake(%this)
	{
		$TwoRes::playing = true;
		
//		$pref::Video::resolution = $pref::TwoRes::GameRes;
//		$pref::Video::fullScreen = $pref::TwoRes::GameFS;
		setScreenMode( firstWord( $pref::TwoRes::gameRes ), getWord( $pref::TwoRes::gameRes, 1 ),
					   getWord( $pref::TwoRes::gameRes, 2 ), $pref::TwoRes::gameFS );
		
		parent::onWake(%this);	
	}
	
	function DisconnectedCleanup()
	{
		parent::DisconnectedCleanup();		
		if ($TwoRes::playing)
		{
			$TwoRes::playing = false;
			$pref::Video::resolution = $pref::TwoRes::MainRes;
			$pref::Video::fullScreen = $pref::TwoRes::MainFS;
			setScreenMode( firstWord( $pref::TwoRes::MainRes ), getWord( $pref::TwoRes::MainRes, 1 ),
						   getWord( $pref::TwoRes::MainRes, 2 ), $pref::TwoRes::MainFS );
		}
	}

	
};

if (!isObject(TwoResOptionsGui))
{
	new GuiControl(TwoResOptionsGui) {
		profile = "GuiDefaultProfile";
		horizSizing = "width";
		vertSizing = "height";
		position = "0 10";
		extent = "400 310";
		minExtent = "400 310";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";

		new GuiTextCtrl() {
			profile = "CenterPrintTextProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "144 10";
			extent = "111 24";
			minExtent = "8 24";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "TwoRes Options";
			maxLength = "255";
		};
		new ShellFieldCtrl() {
			profile = "ShellFieldProfile";
			horizSizing = "relative";
			vertSizing = "relative";
			position = "8 48";
			extent = "180 200";
			minExtent = "16 18";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new GuiTextCtrl() {
				profile = "CenterPrintTextProfile";
				horizSizing = "center";
				vertSizing = "relative";
				position = "34 0";
				extent = "111 24";
				minExtent = "8 24";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Main Resolution";
				maxLength = "255";
			};
			new GuiTextCtrl() {
				profile = "ShellTextRightProfile";
				horizSizing = "center";
				vertSizing = "relative";
				position = "64 85";
				extent = "51 20";
				minExtent = "50 20";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Bit Depth:";
				maxLength = "255";
			};
			new ShellToggleButton(TwoResMainFullScreenTgl) {
				profile = "ShellRadioProfile";
				horizSizing = "center";
				vertSizing = "relative";
				position = "26 143";
				extent = "127 30";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "FULL SCREEN";
				maxLength = "255";
			};
			new GuiTextCtrl() {
				profile = "ShellTextRightProfile";
				horizSizing = "center";
				vertSizing = "relative";
				position = "60 27";
				extent = "60 20";
				minExtent = "60 20";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Resolution:";
				maxLength = "255";
			};
			new ShellPopupMenu(TwoResMainResMenu) {
				profile = "ShellPopupProfile";
				horizSizing = "center";
				vertSizing = "relative";
				position = "10 49";
				extent = "160 36";
				minExtent = "49 36";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Select Resolution";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};
			new ShellPopupMenu(TwoResMainBppMenu) {
				profile = "ShellPopupProfile";
				horizSizing = "center";
				vertSizing = "relative";
				position = "20 107";
				extent = "140 36";
				minExtent = "49 36";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Default";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = "315 274";
			extent = "85 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "TwoRes::Save();";
			helpTag = "0";
			text = "APPLY";
			simpleStyle = "0";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = "232 274";
			extent = "85 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "TwoRes::Reset();";
			helpTag = "0";
			text = "RESET";
			simpleStyle = "0";
		};
		new ShellFieldCtrl() {
			profile = "ShellFieldProfile";
			horizSizing = "relative";
			vertSizing = "relative";
			position = "203 48";
			extent = "180 200";
			minExtent = "16 18";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new GuiTextCtrl() {
				profile = "CenterPrintTextProfile";
				horizSizing = "center";
				vertSizing = "relative";
				position = "31 0";
				extent = "117 24";
				minExtent = "8 24";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Game Resolution";
				maxLength = "255";
			};
			new GuiTextCtrl() {
				profile = "ShellTextRightProfile";
				horizSizing = "center";
				vertSizing = "relative";
				position = "65 85";
				extent = "50 20";
				minExtent = "50 20";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Bit Depth:";
				maxLength = "255";
			};
			new ShellToggleButton(TwoResGameFullScreenTgl) {
				profile = "ShellRadioProfile";
				horizSizing = "center";
				vertSizing = "relative";
				position = "29 143";
				extent = "122 30";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "FULL SCREEN";
				maxLength = "255";
			};
			new GuiTextCtrl() {
				profile = "ShellTextRightProfile";
				horizSizing = "center";
				vertSizing = "relative";
				position = "59 27";
				extent = "61 20";
				minExtent = "60 20";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Resolution:";
				maxLength = "255";
			};
			new ShellPopupMenu(TwoResGameResMenu) {
				profile = "ShellPopupProfile";
				horizSizing = "center";
				vertSizing = "relative";
				position = "12 49";
				extent = "155 36";
				minExtent = "49 36";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Select Resolution";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};
			new ShellPopupMenu(TwoResGameBppMenu) {
				profile = "ShellPopupProfile";
				horizSizing = "center";
				vertSizing = "relative";
				position = "20 107";
				extent = "140 36";
				minExtent = "49 36";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Default";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};
		};
	};

}


 
function TwoRes::Reset()
{
}

function TwoRes::Save()
{
	%selId = TwoResGameResMenu.getSelected();
	if ( %selId == -1 )
		%selId = 0;
	%gameRes = TwoResGameResMenu.getTextById( %selId );

	%selId = TwoResGameBppMenu.getSelected();
	if ( %selId == -1 )
		%selId = 0;
	$pref::TwoRes::GameRes = %gameRes @ " " @ TwoResGameBppMenu.getTextById( %selId );

	%selId = TwoResMainResMenu.getSelected();
	if ( %selId == -1 )
		%selId = 0;
	%mainRes = TwoResMainResMenu.getTextById( %selId );

	%selId = TwoResMainBppMenu.getSelected();
	if ( %selId == -1 )
		%selId = 0;
	$pref::TwoRes::MainRes = %mainRes @ " " @ TwoResMainBppMenu.getTextById( %selId );

	$pref::TwoRes::GameFS = TwoResGameFullScreenTgl.getValue();
	$pref::TwoRes::MainFS = TwoResMainFullScreenTgl.getValue();
	
	if ($pref::TwoRes::MainRes !$= $pref::Video::resolution ||
		$pref::TwoRes::MainFS !$= $pref::Video::fullScreen)
	{
		$pref::Video::resolution = $pref::TwoRes::MainRes;
		$pref::Video::fullScreen = $pref::TwoRes::MainFS;
		setScreenMode( firstWord( $pref::Video::resolution ), getWord( $pref::Video::resolution, 1 ),
						   getWord( $pref::Video::resolution, 2 ), $pref::Video::fullScreen );
	}
}

function TwoResOptionsGui::init(%this, %extent)
{
	if ($pref::TwoRes::MainRes $= "")
	{
		$pref::TwoRes::MainRes = $pref::Video::resolution;
		$pref::TwoRes::MainFS = $pref::Video::fullScreen;
	}
	
}

function TwoResOptionsGui::onWake(%this)
{
	// time for fixing dumb problem with scaling pop down menus
	TwoResGameResMenu.extent = firstWord(TwoResGameResMenu.extent) @ " 36";
	TwoResMainResMenu.extent = firstWord(TwoResMainResMenu.extent) @ " 36";
	TwoResGameBppMenu.extent = firstWord(TwoResGameBppMenu.extent) @ " 36";
	TwoResMainBppMenu.extent = firstWord(TwoResMainBppMenu.extent) @ " 36";

	TwoResGameResMenu.init();
	TwoResMainResMenu.init();
	TwoResGameBppMenu.init();
	TwoResMainBppMenu.init();

	%selId = TwoResGameResMenu.findText(getWords($pref::TwoRes::GameRes, 0, 1));
	if ( %selId == -1 )
		%selId = 0;
	TwoResGameResMenu.setSelected( %selId );

	%selId = TwoResMainResMenu.findText(getWords($pref::TwoRes::MainRes, 0, 1));
	if ( %selId == -1 )
		%selId = 0;
	TwoResMainResMenu.setSelected( %selId );

	%selId = TwoResGameBppMenu.findText(getWord($pref::TwoRes::GameRes, 2));
	if ( %selId == -1 )
		%selId = 0;
	TwoResGameBppMenu.setSelected( %selId );

	%selId = TwoResMainBppMenu.findText(getWord($pref::TwoRes::MainRes, 2));
	if ( %selId == -1 )
		%selId = 0;
	TwoResMainBppMenu.setSelected( %selId );

	if ($pref::TwoRes::GameFS $= "")
		$pref::TwoRes::GameFS = $pref::Video::fullScreen;
	
	TwoResGameFullScreenTgl.setValue("0");
	if ($pref::TwoRes::GameFS $= "1")
		TwoResGameFullScreenTgl.setValue("1");
	
	TwoResMainFullScreenTgl.setValue("0");
	if ($pref::TwoRes::MainFS $= "1")
		TwoResMainFullScreenTgl.setValue("1");
}

function TwoResOptionsGui::onSleep(%this)
{
	echo("sleeping");
	

}

function TwoRes::FullScreenOnAction( %fsButton, %resMenu, %bppMenu, %oldBpp)
{
	// Attempt to maintain current settings:
	%selId = %resMenu.getSelected();
	if ( %selId == -1 )
		%selId = 0;
	%prevRes = %resMenu.getTextById( %selId );

	%resMenu.init();

	%selId = %resMenu.findText( %prevRes );
	if ( %selId == -1 )
		%selId = 0;
	%resMenu.setSelected( %selId );

	if ( %fsButton.getValue() )
	{
		%selId = %bppMenu.findText( %oldBpp );
		if ( %selId == - 1 )
			%selId = 0;
		%bppMenu.setSelected( %selId );
		%bppMenu.setText( %bppMenu.getTextById( %selId ) );
		%bppMenu.setActive( true );
	}
	else
	{
		%bppMenu.setText( "Default" );
		%bppMenu.setActive( false );
	}
}


function TwoRes::InitBppMenu(%bppMenu, %device)
{
	%bppMenu.clear();

	if ( %device $= "Voodoo2" )
		%bppMenu.add( "16", 0 );
	else
	{
		%resList = getResolutionList( %device );
		%resCount = getFieldCount( %resList );
		%count = 0;
		for ( %i = 0; %i < %resCount; %i++ )
		{
			%bpp = getWord( getField( %resList, %i ), 2 );
			
			// Only add to list if it isn't there already:
			if ( %bppMenu.findText( %bpp ) == -1 )
			{
				%bppMenu.add( %bpp, %count );
				%count++;
			}
		}
	}

}

function TwoRes::InitResMenu(%resMenu, %device, %fullScreen)
{
	%resMenu.clear();
	%resList = getResolutionList( %device );
	%resCount = getFieldCount( %resList );
	%deskRes = getDesktopResolution();
	%count = 0;
	for ( %i = 0; %i < %resCount; %i++ )
	{
		%res = getWords( getField( %resList, %i ), 0, 1 );
		
		if ( !%fullScreen )
		{
			if ( firstWord( %res ) >= firstWord( %deskRes ) )
				continue;
			if ( getWord( %res, 1 ) >= getWord( %deskRes, 1 ) )
				continue;
		}
		
		// Only add to list if it isn't there already:
		if ( %resMenu.findText( %res ) == -1 )
		{
			%resMenu.add( %res, %count );
			%count++;
		}
	}
}


function TwoResGameResMenu::init(%this)
{
	TwoRes::InitResMenu(%this, $pref::Video::displayDevice, 
						TwoResGameFullScreenTgl.getValue());
}

function TwoResMainResMenu::init(%this)
{
	TwoRes::InitResMenu(%this, $pref::Video::displayDevice, 
						TwoResMainFullScreenTgl.getValue());
}

function TwoResGameBppMenu::init(%this)
{
	TwoRes::InitBppMenu(%this, $pref::Video::displayDevice);
}

function TwoResMainBppMenu::init(%this)
{
	TwoRes::InitBppMenu(%this, $pref::Video::displayDevice);
}

function TwoResGameFullScreenTgl::onAction(%this)
{
	TwoRes::FullScreenOnAction(%this, TwoResGameResMenu, TwoResGameBppMenu,
							   getWord( $pref::TwoRes::GameRes, 2 ));
}

function TwoResMainFullScreenTgl::onAction(%this)
{
	TwoRes::FullScreenOnAction(%this, TwoResMainResMenu, TwoResMainBppMenu,
							   getWord( $pref::TwoRes::MainRes, 2));
}

activatePackage(TwoRes);